/* CoolTran, traductor de trminos.
 * 
 * Copyright (C) 2007
 *
 * Authors: Javier Garca Palacios <jgarcia1709@gmail.com>
 *          Diego Sevillano de Miguel <sevas85@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 */

import java.sql.Connection;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;



public class Valoracion {

	String tabla = "";
	String numTermino = "";
	String tipo = "";
	Connection con = null;
	boolean valorado=false;
	
	public  Valoracion(String tablaDic,String numeroTermino,String tipoCalificacion,Conexion conexion){
		
		con = conexion.con;
		numTermino = numeroTermino;
		tabla = tablaDic;
		tipo = tipoCalificacion;
	}
	
	
	public void valorarTermino(){
		
		String query="";
		Statement stmt = null;
		ResultSet res = null;
		String existe = "";
		
		query="select count(*) from `valorar` where numtermino = "+numTermino+"  ";
		
		try{
			stmt = con.createStatement();
			res = stmt .executeQuery(query);
			
			while( res.next()){
				
				existe = res.getString(1);
			}	
			
		} catch (SQLException e) {
			System.out.println("Error seleccionando el tipo de valoracion");
			System.out.println("la query es "+query);
		}
		
		if (existe.equals("0") ){
		
		query="insert into `valorar` VALUES ("+numTermino+",'"+tabla+"', ";
		
		if (tipo.equals("0")){
			query=query+"1 , 0 , 0 ,3,0 )";
			
			
		}
		if (tipo.equals("1")){
			query=query+"0 , 1 , 0 ,1 ,0 )";
			
			
		}
		if (tipo.equals("2")){
			query=query+"0 , 0 , 1 ,-1 ,0 )";
			
			
		}
		
		
		}else{
			
			query="update  `valorar` v  SET ";
				
			
			if (tipo.equals("0")){
				query=query+ " v.bien = v.bien + 1 , v.media = v.media +3 ";
				
				
			}
			if (tipo.equals("1")){
				query=query+ " v.regular = v.regular + 1 , v.media = v.media + 1";
				
				
			}
			if (tipo.equals("2")){
				query=query+ " v.mal = v.mal + 1 , v.media = v.media - 1";
				
				
			}
					
			query=query+ " WHERE numtermino = "+numTermino+" and tabla = '"+tabla+"' ";	
			
		}
		
		try {
				System.out.println("la query  es "+query);
				stmt = con.createStatement();
				stmt.executeUpdate(query);
	
				valorado=true;
		
		} catch (SQLException e) {
			
			valorado=false;
			
			System.out.println("Error insertando valoracion");
			System.out.println("la query es "+query);
		}
	}
	
	public boolean isValorado(){	
		return valorado;
	}
	
}
